// $ANTLR 2.7.7 (20060906): "Expression.g" -> "Parser.cs"$

using System.IO;

namespace Agilent.Vee.EvoExample.ExpressionGraph
{
	// Generate the header common to all output files.
	using System;
	
	using TokenBuffer              = antlr.TokenBuffer;
	using TokenStreamException     = antlr.TokenStreamException;
	using TokenStreamIOException   = antlr.TokenStreamIOException;
	using ANTLRException           = antlr.ANTLRException;
	using LLkParser = antlr.LLkParser;
	using Token                    = antlr.Token;
	using IToken                   = antlr.IToken;
	using TokenStream              = antlr.TokenStream;
	using RecognitionException     = antlr.RecognitionException;
	using NoViableAltException     = antlr.NoViableAltException;
	using MismatchedTokenException = antlr.MismatchedTokenException;
	using SemanticException        = antlr.SemanticException;
	using ParserSharedInputState   = antlr.ParserSharedInputState;
	using BitSet                   = antlr.collections.impl.BitSet;
	using AST                      = antlr.collections.AST;
	using ASTPair                  = antlr.ASTPair;
	using ASTFactory               = antlr.ASTFactory;
	using ASTArray                 = antlr.collections.impl.ASTArray;
	
	public 	class Parser : antlr.LLkParser
	{
		public const Int32 EOF = 1;
		public const Int32 NULL_TREE_LOOKAHEAD = 3;
		public const Int32 SIGN_MINUS = 4;
		public const Int32 SIGN_PLUS = 5;
		public const Int32 LPAREN = 6;
		public const Int32 RPAREN = 7;
		public const Int32 PLUS = 8;
		public const Int32 MINUS = 9;
		public const Int32 MUL = 10;
		public const Int32 DIV = 11;
		public const Int32 POW = 12;
		public const Int32 ABS = 13;
		public const Int32 ACOS = 14;
		public const Int32 ASIN = 15;
		public const Int32 ATAN = 16;
		public const Int32 COS = 17;
		public const Int32 EXP = 18;
		public const Int32 LOG = 19;
		public const Int32 LOG10 = 20;
		public const Int32 SQRT = 21;
		public const Int32 SIN = 22;
		public const Int32 TAN = 23;
		public const Int32 NUMBER = 24;
		public const Int32 X = 25;
		public const Int32 WS = 26;
		
		
		protected void initialize()
		{
			tokenNames = tokenNames_;
			initializeFactory();
		}
		
		
		protected Parser(TokenBuffer tokenBuf, Int32 k) : base(tokenBuf, k)
		{
			initialize();
		}
		
		public Parser(TokenBuffer tokenBuf) : this(tokenBuf,1)
		{
		}
		
		protected Parser(TokenStream lexer, Int32 k) : base(lexer,k)
		{
			initialize();
		}
		
		public Parser(TokenStream lexer) : this(lexer,1)
		{
		}
		
		public Parser(ParserSharedInputState state) : base(state,1)
		{
			initialize();
		}
		
	public void imaginaryTokenDefinitions() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST imaginaryTokenDefinitions_AST = null;
		
		try {      // for error handling
			AST tmp20_AST = null;
			tmp20_AST = astFactory.create(LT(1));
			astFactory.addASTChild(ref currentAST, tmp20_AST);
			match(SIGN_MINUS);
			AST tmp21_AST = null;
			tmp21_AST = astFactory.create(LT(1));
			astFactory.addASTChild(ref currentAST, tmp21_AST);
			match(SIGN_PLUS);
			imaginaryTokenDefinitions_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_0_);
		}
		returnAST = imaginaryTokenDefinitions_AST;
	}
	
	public void expr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expr_AST = null;
		
		try {      // for error handling
			AST tmp22_AST = null;
			tmp22_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(ref currentAST, tmp22_AST);
			match(LPAREN);
			sumExpr();
			astFactory.addASTChild(ref currentAST, returnAST);
			match(RPAREN);
			expr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_1_);
		}
		returnAST = expr_AST;
	}
	
	public void sumExpr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST sumExpr_AST = null;
		
		try {      // for error handling
			mulExpr();
			astFactory.addASTChild(ref currentAST, returnAST);
			{    // ( ... )*
				for (;;)
				{
					if ((LA(1)==PLUS||LA(1)==MINUS))
					{
						{
							switch ( LA(1) )
							{
							case PLUS:
							{
								AST tmp24_AST = null;
								tmp24_AST = astFactory.create(LT(1));
								astFactory.makeASTRoot(ref currentAST, tmp24_AST);
								match(PLUS);
								break;
							}
							case MINUS:
							{
								AST tmp25_AST = null;
								tmp25_AST = astFactory.create(LT(1));
								astFactory.makeASTRoot(ref currentAST, tmp25_AST);
								match(MINUS);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							 }
						}
						mulExpr();
						astFactory.addASTChild(ref currentAST, returnAST);
					}
					else
					{
						goto _loop6_breakloop;
					}
					
				}
_loop6_breakloop:				;
			}    // ( ... )*
			sumExpr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_2_);
		}
		returnAST = sumExpr_AST;
	}
	
	public void mulExpr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST mulExpr_AST = null;
		
		try {      // for error handling
			powExpr();
			astFactory.addASTChild(ref currentAST, returnAST);
			{    // ( ... )*
				for (;;)
				{
					if ((LA(1)==MUL||LA(1)==DIV))
					{
						{
							switch ( LA(1) )
							{
							case MUL:
							{
								AST tmp26_AST = null;
								tmp26_AST = astFactory.create(LT(1));
								astFactory.makeASTRoot(ref currentAST, tmp26_AST);
								match(MUL);
								break;
							}
							case DIV:
							{
								AST tmp27_AST = null;
								tmp27_AST = astFactory.create(LT(1));
								astFactory.makeASTRoot(ref currentAST, tmp27_AST);
								match(DIV);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							 }
						}
						powExpr();
						astFactory.addASTChild(ref currentAST, returnAST);
					}
					else
					{
						goto _loop10_breakloop;
					}
					
				}
_loop10_breakloop:				;
			}    // ( ... )*
			mulExpr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_3_);
		}
		returnAST = mulExpr_AST;
	}
	
	public void powExpr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST powExpr_AST = null;
		
		try {      // for error handling
			{
				switch ( LA(1) )
				{
				case LPAREN:
				case PLUS:
				case MINUS:
				case NUMBER:
				case X:
				{
					signExpr();
					astFactory.addASTChild(ref currentAST, returnAST);
					break;
				}
				case ABS:
				case ACOS:
				case ASIN:
				case ATAN:
				case COS:
				case EXP:
				case LOG:
				case LOG10:
				case SQRT:
				case SIN:
				case TAN:
				{
					funcExpr();
					astFactory.addASTChild(ref currentAST, returnAST);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				 }
			}
			{
				switch ( LA(1) )
				{
				case POW:
				{
					AST tmp28_AST = null;
					tmp28_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp28_AST);
					match(POW);
					{
						switch ( LA(1) )
						{
						case LPAREN:
						case PLUS:
						case MINUS:
						case NUMBER:
						case X:
						{
							signExpr();
							astFactory.addASTChild(ref currentAST, returnAST);
							break;
						}
						case ABS:
						case ACOS:
						case ASIN:
						case ATAN:
						case COS:
						case EXP:
						case LOG:
						case LOG10:
						case SQRT:
						case SIN:
						case TAN:
						{
							funcExpr();
							astFactory.addASTChild(ref currentAST, returnAST);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						 }
					}
					break;
				}
				case RPAREN:
				case PLUS:
				case MINUS:
				case MUL:
				case DIV:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				 }
			}
			powExpr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_4_);
		}
		returnAST = powExpr_AST;
	}
	
	public void signExpr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST signExpr_AST = null;
		IToken  m = null;
		AST m_AST = null;
		IToken  p = null;
		AST p_AST = null;
		
		try {      // for error handling
			{
				switch ( LA(1) )
				{
				case MINUS:
				{
					m = LT(1);
					m_AST = astFactory.create(m);
					astFactory.makeASTRoot(ref currentAST, m_AST);
					match(MINUS);
					m_AST.setType(SIGN_MINUS);
					break;
				}
				case PLUS:
				{
					p = LT(1);
					p_AST = astFactory.create(p);
					astFactory.makeASTRoot(ref currentAST, p_AST);
					match(PLUS);
					p_AST.setType(SIGN_PLUS);
					break;
				}
				case LPAREN:
				case NUMBER:
				case X:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				 }
			}
			atom();
			astFactory.addASTChild(ref currentAST, returnAST);
			signExpr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_1_);
		}
		returnAST = signExpr_AST;
	}
	
	public void funcExpr() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST funcExpr_AST = null;
		
		try {      // for error handling
			{
				switch ( LA(1) )
				{
				case ABS:
				{
					AST tmp29_AST = null;
					tmp29_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp29_AST);
					match(ABS);
					break;
				}
				case ACOS:
				{
					AST tmp30_AST = null;
					tmp30_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp30_AST);
					match(ACOS);
					break;
				}
				case ASIN:
				{
					AST tmp31_AST = null;
					tmp31_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp31_AST);
					match(ASIN);
					break;
				}
				case ATAN:
				{
					AST tmp32_AST = null;
					tmp32_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp32_AST);
					match(ATAN);
					break;
				}
				case COS:
				{
					AST tmp33_AST = null;
					tmp33_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp33_AST);
					match(COS);
					break;
				}
				case EXP:
				{
					AST tmp34_AST = null;
					tmp34_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp34_AST);
					match(EXP);
					break;
				}
				case LOG:
				{
					AST tmp35_AST = null;
					tmp35_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp35_AST);
					match(LOG);
					break;
				}
				case LOG10:
				{
					AST tmp36_AST = null;
					tmp36_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp36_AST);
					match(LOG10);
					break;
				}
				case SQRT:
				{
					AST tmp37_AST = null;
					tmp37_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp37_AST);
					match(SQRT);
					break;
				}
				case SIN:
				{
					AST tmp38_AST = null;
					tmp38_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp38_AST);
					match(SIN);
					break;
				}
				case TAN:
				{
					AST tmp39_AST = null;
					tmp39_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(ref currentAST, tmp39_AST);
					match(TAN);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				 }
			}
			expr();
			astFactory.addASTChild(ref currentAST, returnAST);
			funcExpr_AST = currentAST.root;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_1_);
		}
		returnAST = funcExpr_AST;
	}
	
	public void atom() //throws RecognitionException, TokenStreamException
{
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST atom_AST = null;
		
		try {      // for error handling
			switch ( LA(1) )
			{
			case NUMBER:
			{
				AST tmp40_AST = null;
				tmp40_AST = astFactory.create(LT(1));
				astFactory.addASTChild(ref currentAST, tmp40_AST);
				match(NUMBER);
				atom_AST = currentAST.root;
				break;
			}
			case X:
			{
				AST tmp41_AST = null;
				tmp41_AST = astFactory.create(LT(1));
				astFactory.addASTChild(ref currentAST, tmp41_AST);
				match(X);
				atom_AST = currentAST.root;
				break;
			}
			case LPAREN:
			{
				expr();
				astFactory.addASTChild(ref currentAST, returnAST);
				atom_AST = currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			 }
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			recover(ex,tokenSet_1_);
		}
		returnAST = atom_AST;
	}
	
	private void initializeFactory()
	{
		if (astFactory == null)
		{
			astFactory = new ASTFactory();
		}
		initializeASTFactory( astFactory );
	}
	static public void initializeASTFactory( ASTFactory factory )
	{
		factory.setMaxNodeType(26);
	}
	
	public static readonly string[] tokenNames_ = new string[] {
		@"""<0>""",
		@"""EOF""",
		@"""<2>""",
		@"""NULL_TREE_LOOKAHEAD""",
		@"""SIGN_MINUS""",
		@"""SIGN_PLUS""",
		@"""LPAREN""",
		@"""RPAREN""",
		@"""PLUS""",
		@"""MINUS""",
		@"""MUL""",
		@"""DIV""",
		@"""POW""",
		@"""ABS""",
		@"""ACOS""",
		@"""ASIN""",
		@"""ATAN""",
		@"""COS""",
		@"""EXP""",
		@"""LOG""",
		@"""LOG10""",
		@"""SQRT""",
		@"""SIN""",
		@"""TAN""",
		@"""NUMBER""",
		@"""X""",
		@"""WS"""
	};
	
	private static long[] mk_tokenSet_0_()
	{
		long[] data = { 2L, 0L};
		return data;
	}
	public static readonly BitSet tokenSet_0_ = new BitSet(mk_tokenSet_0_());
	private static long[] mk_tokenSet_1_()
	{
		long[] data = { 8064L, 0L};
		return data;
	}
	public static readonly BitSet tokenSet_1_ = new BitSet(mk_tokenSet_1_());
	private static long[] mk_tokenSet_2_()
	{
		long[] data = { 128L, 0L};
		return data;
	}
	public static readonly BitSet tokenSet_2_ = new BitSet(mk_tokenSet_2_());
	private static long[] mk_tokenSet_3_()
	{
		long[] data = { 896L, 0L};
		return data;
	}
	public static readonly BitSet tokenSet_3_ = new BitSet(mk_tokenSet_3_());
	private static long[] mk_tokenSet_4_()
	{
		long[] data = { 3968L, 0L};
		return data;
	}
	public static readonly BitSet tokenSet_4_ = new BitSet(mk_tokenSet_4_());
	
}
}
